/*
* Template: src/main/takatuka/templates/EntityPresentationAbstractSearchView.vm
*/
package de.ivu.elect.presentation.person;

import java.util.List;

import javax.annotation.PostConstruct;
import javax.enterprise.context.RequestScoped;
import javax.enterprise.event.Observes;
import javax.enterprise.event.Reception;
import javax.enterprise.inject.Instance;
import javax.faces.context.FacesContext;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;
import org.apache.deltaspike.core.api.scope.ViewAccessScoped;

import de.ivu.elect.business.security.UseCasePermission;

import de.ivu.elect.business.person.boundary.AbstractBerufSearchParameters;
import de.ivu.elect.business.person.boundary.BerufChangeEvent;
import de.ivu.elect.business.person.boundary.BerufConversationStore;
import de.ivu.elect.business.person.boundary.BerufExtendedDAO;
import de.ivu.elect.business.person.boundary.BerufSearch;
import de.ivu.elect.business.person.boundary.BerufSearchParameters;
import de.ivu.elect.business.wahl.boundary.WahlSelectChangeEvent;
import de.ivu.elect.business.wahl.boundary.WahlterminSelectChangeEvent;
import de.ivu.elect.business.person.entity.Beruf;
import de.ivu.elect.business.person.entity.BerufMeta;
import de.ivu.elect.jee.entity.EagerLoadingCollector;
import de.ivu.elect.presentation.AbstractElectSearchView;
import de.ivu.elect.presentation.View;

@ViewAccessScoped
@Named(AbstractBerufSearchView.COMPONENT_NAME)
@View(viewId = AbstractBerufSearchView.VIEW_ID, useCase = UseCasePermission.BERUF_SEARCH)
public abstract class AbstractBerufSearchView extends AbstractElectSearchView<Beruf> {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "berufSearchView";
  
  public static final String VIEW_ID = "/person/beruf-search.xhtml";

  @Inject
  private transient RequestHandlerAbstractBerufSearchView requestHandler;

  @Inject
  private transient BerufExtendedDAO extendedDAO;

  @Inject
  @ConversationGroup(BerufConversationStore.class)
  protected transient BerufConversationStore conversationStore;

  @Inject
  protected transient BerufSearch search;

  @Inject
  @ConversationGroup(AbstractBerufSearchParameters.class)
  protected transient BerufSearchParameters searchParameters;

  @Inject
  protected transient BerufMeta entityMeta;

  public AbstractBerufSearchView() {
    super();
  }

  @Override
  protected String getViewId() {
    return VIEW_ID;
  }

  public boolean isEntitySelected() {
    return conversationStore.getEntityPK() != null;
  }

  public Beruf getSelectedEntity() {
    if (isEntitySelected()) {
      return extendedDAO.findByPrimaryKey(conversationStore.getEntityPK());
    }

    return null;
  }

  public void setSelectedEntity(Beruf entity) {
    if (entity == null) {
      conversationStore.setEntityPK(null);
    } else {
      conversationStore.setEntityPK(entity.getPk());
    }
  }

  @Override
  public BerufSearchParameters getSearchParameters() {
    return searchParameters;
  }

  public EagerLoadingCollector<Beruf> getEagerLoadingCollector() {
    return EagerLoadingCollector.<Beruf> create();
  }

  @Override
  public List<Beruf> getSearchResult() {
    requestHandler.nothing(); // ELECT-248

    return super.getSearchResult();
  }

  @Override
  protected List<Beruf> performSearch() {
    return search.getSearchResult(getSearchParameters(), getEagerLoadingCollector());
  }

  public void onBerufChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) BerufChangeEvent event) {
    resetSearchResult();
  }

  // ELECT-2231    ELECT-2250
  /*
   * searchParameters sind von der zur Bearbeitung ausgewählten Wahl abhängig.
   */
  public void onWahlSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlSelectChangeEvent event) {
    reset();
  }

  /*
   * searchParameters sind vom zur Bearbeitung ausgewählten Wahltermin abhängig.
   */
  public void onWahlterminSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlterminSelectChangeEvent event) {
    reset();
  }

  @RequestScoped
  // elect: Das Suchergebnis soll nur einmal pro Request geladen werden, daher gibt es dieses "Konstrukt" aus "SearchView" und "RequestHandlerAbstract"
  public static class RequestHandlerAbstractBerufSearchView {

    @View
    @Inject
    private transient Instance<AbstractBerufSearchView> searchViews;

    @PostConstruct
    public void init() {
      // ELECT-3543 Doppelte Suchen vermeiden - Suchergebnis für Request nicht beim POST-löschen
      if (!FacesContext.getCurrentInstance().isPostback()) {
        for (AbstractBerufSearchView searchView : searchViews) {
          searchView.resetSearchResult();
        }
      }
    }

    public void nothing() {
      // Do nothing.
    }
  }
}
